## shc 3.7

=== Makefile ===
# Makefile
#

INSTALL_PATH = /usr/local

# For SCO
CFLAGS = -b elf -O -D_SVID

# For IRIX
CFLAGS = -xansi -fullwarn -O3 -g0

# For Solaris
CFLAGS = -fast -xO4 -s -v -Xa

# For HPUX
CFLAGS = -Wall -O -Ae

# For OSF1
CFLAGS = -w -verbose -fast -std1 -g0

# For GNU C compiler
CFLAGS = -Wall -O6 -pedantic

SHELL = /bin/sh

all: shc ask_for_test

shc: shc.c
	$(CC) $(CFLAGS) $< -o $@

ask_for_test:
	@echo '***	Do you want to probe shc with a test script?'
	@echo '***	Please try...	make test'

test: make_the_test ask_for_strings

make_the_test: match.x
	@echo '***	Running a compiled test script!'
	@echo '***	It must show files with substring "sh" in your PATH...'
	./match.x sh

match.x: match.x.c
	$(CC) $(CFLAGS) $< -o $@

match.x.c: shc match
	@echo '***	Compiling script "match"'
	CFLAGS="$(CFLAGS)" ./shc -v -r -f match

ask_for_strings:
	@echo '***	Do you want to see strings in the generated binary?'
	@echo '***	Please try...	make strings'

strings: make_the_strings ask_for_install

make_the_strings: match.x
	@echo '***	Running: "strings -n 5 '$<'"'
	@echo '***	It must show no sensible information...'
	strings -n 5 $<

ask_for_install:
	@echo '***	Do you want to install shc?'
	@echo '***	Please try...	make install'

install: shc
	@echo '***	Installing shc and shc.1 on '$(INSTALL_PATH)
	@echo -n '***	Do you want to continue? '; read ANS; case "$$ANS" in y|Y|yes|Yes|YES) ;; *) exit 1;; esac;
	install -c -s shc $(INSTALL_PATH)/bin/
	install -c -m 644 shc.1 $(INSTALL_PATH)/man/man3/

clean:
	rm -f *.o *~ *.x.c

cleanall: clean
	rm -f shc *.x

## shc 3.8.6

=== Makefile ===
--- 
+++ 
@@ -26,7 +26,7 @@
 all: shc ask_for_test
 
 shc: shc.c
-	$(CC) $(CFLAGS) $< -o $@
+	$(CC) $(CFLAGS) $@.c -o $@
 
 ask_for_test:
 	@echo '***	Do you want to probe shc with a test script?'
@@ -39,12 +39,9 @@
 	@echo '***	It must show files with substring "sh" in your PATH...'
 	./match.x sh
 
-match.x: match.x.c
-	$(CC) $(CFLAGS) $< -o $@
-
-match.x.c: shc match
+match.x: shc match
 	@echo '***	Compiling script "match"'
-	CFLAGS="$(CFLAGS)" ./shc -v -r -f match
+	CFLAGS="$(CFLAGS)" ./shc -v -f match
 
 ask_for_strings:
 	@echo '***	Do you want to see strings in the generated binary?'
@@ -53,9 +50,9 @@
 strings: make_the_strings ask_for_install
 
 make_the_strings: match.x
-	@echo '***	Running: "strings -n 5 '$<'"'
+	@echo '***	Running: "strings -n 5 'match.x'"'
 	@echo '***	It must show no sensible information...'
-	strings -n 5 $<
+	strings -n 5 match.x
 
 ask_for_install:
 	@echo '***	Do you want to install shc?'
@@ -65,7 +62,7 @@
 	@echo '***	Installing shc and shc.1 on '$(INSTALL_PATH)
 	@echo -n '***	Do you want to continue? '; read ANS; case "$$ANS" in y|Y|yes|Yes|YES) ;; *) exit 1;; esac;
 	install -c -s shc $(INSTALL_PATH)/bin/
-	install -c -m 644 shc.1 $(INSTALL_PATH)/man/man3/
+	install -c -m 644 shc.1 $(INSTALL_PATH)/man/man1/
 
 clean:
 	rm -f *.o *~ *.x.c

## shc 3.8.7

=== Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
 CFLAGS = -w -verbose -fast -std1 -g0
 
 # For GNU C compiler
-CFLAGS = -Wall -O6 -pedantic
+CFLAGS = -Wall -O6 # -pedantic
 
 SHELL = /bin/sh
 
@@ -47,12 +47,25 @@
 	@echo '***	Do you want to see strings in the generated binary?'
 	@echo '***	Please try...	make strings'
 
-strings: make_the_strings ask_for_install
+strings: make_the_strings ask_for_expiration
 
 make_the_strings: match.x
 	@echo '***	Running: "strings -n 5 'match.x'"'
 	@echo '***	It must show no sensible information...'
 	strings -n 5 match.x
+
+ask_for_expiration:
+	@echo '***	Do you want to probe expiration date?'
+	@echo '***	Please try...	make expiration'
+
+expiration: til_yesterday ask_for_install
+
+til_yesterday: shc match
+	@echo '***	Compiling "match" to expired date'
+	CFLAGS="$(CFLAGS)" ./shc -vvv -e `date "+%d/%m/%Y"` -f match
+	@echo '***	Running a compiled test script!'
+	@echo '***	It must fail showing "./match.x: has expired!"'
+	./match.x
 
 ask_for_install:
 	@echo '***	Do you want to install shc?'

=== debian/changelog ===
shc (3.8.7-2) unstable; urgency=medium

  * Fix ptraceable directive so that it can work out of box under Ubuntu

 -- Tong Sun <suntong001@users.sourceforge.net>  Sun, 07 Sep 2014 03:15:49 +0000

shc (3.8.7-1) unstable; urgency=low

  * Initial Debian Release (Closes: #735946)

 -- Tong Sun <suntong001@users.sourceforge.net>  Tue, 14 Jan 2014 17:25:58 -0500

=== debian/control ===
Source: shc
Section: devel
Priority: optional
Maintainer: Tong Sun <suntong001@users.sourceforge.net>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.5
Homepage: http://www.datsi.fi.upm.es/~frosal/
Vcs-Git: git://github.com/shc-build.git
Vcs-Browser: https://github.com/suntong001/shc-build

Package: shc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Generic shell script compiler
 shc creates a stripped binary executable from shell script.
 .
 shc encodes and encrypts a shell script and generates C source code with
 the added expiration capability. Its main purpose is to protect your shell
 scripts from modification or inspection.  You can use it if you wish to
 distribute your scripts but don't want them to be easily readable by other
 people or if you need to hide passwords.

## shc 3.8.9b

=== debian/changelog ===
shc (3.8.9b-1) unstable; urgency=low

  * new upstream release (3.8.9b)
  * bump up Standards-Version to 3.9.6
  * remove change-Makefile-for-Debian.diff patch
  * add change-makefile-for-Debian.diff patch
  * drop debian/README.source as the 3.8.9 bug has been fixed

 -- Tong Sun <suntong001@users.sourceforge.net>  Wed, 16 Sep 2015 03:22:50 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Tong Sun <suntong001@users.sourceforge.net>
 Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://www.datsi.fi.upm.es/~frosal/
 Vcs-Git: git://github.com/shc-build.git
 Vcs-Browser: https://github.com/suntong001/shc-build

=== debian/watch ===
version=3
http://www.datsi.fi.upm.es/~frosal/sources/shc-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## shc 3.9.6

=== debian/changelog ===
shc (3.9.6-1) unstable; urgency=medium

  * Fix for infinite loop (Closes: #861180)
  * Fix issue #36 (at https://github.com/neurobin/shc/issues/36)
  * Fix issue #38 (at https://github.com/neurobin/shc/issues/38)

 -- Tong Sun <suntong001@users.sourceforge.net>  Sun, 08 Jul 2018 15:11:21 -0400

=== debian/control ===
Source: shc
Section: devel
Priority: optional
Maintainer: Tong Sun <suntong001@users.sourceforge.net>
Build-Depends: debhelper (>= 11)
Standards-Version: 4.1.5
Homepage: http://neurobin.github.io/shc
Vcs-Git: https://github.com/neurobin/shc.git
Vcs-Browser: https://github.com/neurobin/shc.git

Package: shc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Shell script compiler
 SHC is a generic shell script compiler.
 It takes a script, which is specified on the command line and produces
 C source code. The generated source code is then compiled and linked to
 produce a stripped binary.
 .
 The compiled binary will still be dependent on the shell specified in
 the first line of the shell code, thus shc does not create completely
 independent binaries.
 .
 shc itself is not a compiler such as cc,
 it rather encodes and encrypts a shell script and generates C source
 code with the added expiration capability. It then uses the system
 compiler to compile a stripped binary which behaves exactly like the
 original script. Upon execution, the compiled binary will decrypt and
 execute the code with the shells' -c option.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/shc-$1.tar.gz/,\
pgpsigurlmangle=s/archive.*\//releases\/download\//;\
s/v?(\d\S*)\.tar\.gz/$1\/shc-$1.tar.gz/;\
s/$/.asc/ \
  https://github.com/neurobin/shc/tags .*/v?(\d\S*)\.tar\.gz

## shc 4.0.3

=== debian/changelog ===
shc (4.0.3-1) unstable; urgency=medium

  * Maintainer upload
  * Merge the NMU from the NMU-master branch
    * New upstream version 4.0.3
    * debian/control:
      - Added 'Rules-Requires-Root: no' to debian/control source stanza.
      - Bumped Standards-Version to 4.4.1.
      - Updated upstream address in Homepage field.
    * debian/copyright:
      - Added a comment in header to quote the original upstream homepage.
      - Added rights for all upstreams.
      - Added Upstream-Contact field.
      - Added Eriberto as packager.
    * debian/patches/010_fix-rc-path.patch: created to fix 'rc' path to allow
      the build system run tests.
    * debian/salsa-ci.yml: created to provide CI tests via Salsa.
    * debian/tests/*: created to provide some trivial CI tests.
    * debian/watch: remade to look at releases instead of tags.
  * fix package-uses-old-debhelper-compat-version 12
  * fix "source: out-of-date-standards-version" problem
  * update copyright year for packager
  * remove broken tests that failed since day one

 -- Tong Sun <suntong001@users.sourceforge.net>  Sun, 08 Nov 2020 15:42:56 +0100

shc (4.0.3-0.1) unstable; urgency=medium

  * Non-maintainer upload. (Closes: #942544)
  * New upstream version 4.0.3
  * Using new DH level format. Consequently:
      - debian/compat: removed.
      - debian/control: changed from 'debhelper' to 'debhelper-compat' in
        Build-Depends field and bumped level to 12.
  * debian/control:
      - Added ash, ksh, rc, tcsh, zsh to Build-Depends field to allow 'make
        test' command work fine.
      - Added 'Rules-Requires-Root: no' to debian/control source stanza.
      - Bumped Standards-Version to 4.4.1.
      - Updated upstream address in Homepage field.
      - Updated VCS fields to use Salsa.
  * debian/copyright:
      - Added a comment in header to quote the original upstream homepage.
      - Added rights for all upstreams.
      - Added Upstream-Contact field.
      - Fixed rights for packagers.
  * debian/rules:
      - Enabled DEB_BUILD_MAINT_OPTIONS variable to provide a full hardening to
        final binary.
      - Removed all trash.
  * debian/patches/010_fix-rc-path.patch: created to fix 'rc' path to allow the
    build system run tests.
  * debian/salsa-ci.yml: created to provide CI tests via Salsa.
  * debian/tests/*: created to provide some trivial CI tests.
  * debian/upstream/signing-key.asc: removed because the upstream didn't sign
    the tarballs since 3.9.6 version. Currently, it can result in a rejection
    when uploading the package.
  * debian/watch: remade to look at releases instead of tags.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 17 Oct 2019 13:47:33 -0300

shc (4.0.2-1) UNRELEASED; urgency=medium

  * New upstream version 4.0.2
  * - [!] fix all reported package issues with: new DH level, new
      Standards-Version, changes in description, updates rules, copyright etc
      in debian
  * - [!] fix copyright, deprecated d/compat, and warning of
      testsuite-autopkgtest-missing, hardening-no-bindnow. Thanks to
      Eriberto <eriberto@eriberto.pro.br>
  * - [+] add DEP-12 upstream metadata
  * - [!] fix Vcs address

 -- Tong Sun <suntong001@users.sourceforge.net>  Sat, 06 Jul 2019 12:17:45 -0400

shc (4.0.1+git20190127.699738e-1) UNRELEASED; urgency=medium

  * New upstream release (4.0.1).
  * - [!] fix copyright & home url
  * - [-] remove contributors from the Debian copyright file
  * - [!] fix watch file download filename

 -- Tong Sun <suntong001@users.sourceforge.net>  Sat, 27 Apr 2019 19:40:46 +0000

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,12 @@
 Section: devel
 Priority: optional
 Maintainer: Tong Sun <suntong001@users.sourceforge.net>
-Build-Depends: debhelper (>= 11)
-Standards-Version: 4.1.5
-Homepage: http://neurobin.github.io/shc
-Vcs-Git: https://github.com/neurobin/shc.git
-Vcs-Browser: https://github.com/neurobin/shc.git
+Build-Depends: debhelper-compat (= 13), ash, ksh, rc, tcsh, zsh
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
+Homepage: https://neurobin.org/projects/softwares/unix/shc/
+Vcs-Browser: https://salsa.debian.org/debian/shc
+Vcs-Git: https://salsa.debian.org/debian/shc.git
 
 Package: shc
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

devi := $(shell lsb_release -r -s | cut -d '.'  -f1)
ifeq ($(shell if [ $(devi) -gt 5 ] ; then echo gt ; else echo lt ; fi),gt)
   DEBVE2=yes
else
   DEBVE2=no
endif


ifeq ($(DEBVE2),yes)
%:
	dh $@  --with autotools_dev


override_dh_auto_test:
	dh_auto_test || true

else
%:
	dh $@

override_dh_auto_test:
	true

endif

override_dh_auto_clean:
	dh_auto_clean || true

=== debian/tests/control ===
Test-Command: shc -A
Restrictions: allow-stderr

Test-Command: shc -C
Restrictions: allow-stderr

Test-Command: shc -h
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://github.com/neurobin/shc/releases .*/archive/(?:shc-|v)?(\d\S+)\.tar\.(?:bz2|gz|xz)

## shc cgi-bin-20250801

=== Makefile ===
# Makefile for shc and sunah programs
# Miroslav Broz (miroslav.broz@email.cz), Jan 6th 2005

# installation directories (change them to $(HOME)/shc,
# if you do not have root privilegs)
PREFIX = /usr/local
BINDIR = $(PREFIX)/bin
LIBDIR = $(PREFIX)/lib/shc
DOCDIR = $(PREFIX)/doc/shc
MANDIR = $(PREFIX)/man/man1

# this is the FINAL library directory (set this variable correctly in shc.spec and debian/rules!)
LIBSRC = $(LIBDIR)
SHCDEST = $(DOCDIR)/demo

# compiler and options
F77 = gfortran
FFLAGS = -O3

# necessary object files
obj = a.o

# temporary data files
dat =	analema.dat analema_prumet.dat \
	azimut_prumet.dat azimut_rysky.dat \
	ciselnik.dat ciselnik.plt \
	datum.dat datum_prumet.dat \
	hodin.dat hodin_okraj.dat hodin_prumet.dat hodin_rysky.dat \
	horiz.dat horiz_rysky.dat \
	korekce.dat nodus.dat \
	temporal_prumet.dat temporal_rysky.dat \
	vychod_prumet.dat vychod_rysky.dat \
	vyska_prumet.dat \
	zapad_prumet.dat zapad_rysky.dat \
	popisky.dat popisky.plt popisky.ps \
	shc.out shc.png shc.ps shc.eps shc_A4.ps \
	shc.tmp shc_A4.tmp shc.zip \
	sunah.in

all : shcnox sunah shc

shcnox : shcnox.f $(obj)
	$(F77) $(FFLAGS) $(obj) -o $@ $<

sunah : sunah.f $(obj)
	$(F77) $(FFLAGS) $(obj) -o $@ $<

shc : shc.tcl FORCE
	./libsrc.awk $(LIBSRC) shc.tcl > shc
	chmod +x shc
	./cstocs.sh

$(obj) : %.o:%.f
	$(F77) $(FFLAGS) -c $<

install: all
	install -d $(BINDIR) $(LIBDIR) $(DOCDIR) $(MANDIR) $(SHCDEST)
	install shcnox sunah shc shc_eps.awk shc_A4.awk popisky.awk $(BINDIR)
	install -m 644 README HISTORY shc.in sunah.in_example azed.pl azed.in doc/* $(DOCDIR)
	install -m 644 demo/*.shc $(SHCDEST)
	install -m 644 README shc.dat shc_x11.plt shc.gif Luxi.pfa $(LIBDIR)
	./libsrc.awk $(LIBSRC) shc.plt > $(LIBDIR)/shc.plt
	chmod 644 $(LIBDIR)/shc.plt
	install gnuplot gnuplot_x11 $(LIBDIR)
	gzip -c shc.1 > shc.1.gz
	install -m 644 shc.1.gz $(MANDIR)

dist : all clean
	./dist.sh

clean : FORCE
	rm -f $(obj) $(dat)
	cd windows/; rm -f $(dat)

mrproper: clean
	rm -f shcnox sunah shc
	rm -f shc.1.gz
	rm -rf debian/shc

FORCE :
